/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __network_ChunkReciever_h__
#define __network_ChunkReciever_h__

namespace fe
{

class ChunkReceiver;

class ChunkReceiverTask: public Thread::Functor
{
	public:
						ChunkReceiverTask(void);
virtual	void			operate(void);

		sp<ChunkSpool>	m_spChunkSpool;
		sp<Socket>		m_spSocket;
		ChunkReceiver	*m_pChunkReceiver;
};

class ChunkReceiver : public Component
{
	public:
				ChunkReceiver(void);
virtual			~ChunkReceiver(void);

virtual	void	start(sp<ChunkSpool> spChunkSpool, sp<Socket> spSocket);
virtual	void	stop(void);
virtual	bool	live(void);

virtual	void	setLive(bool setting);

		void	setPolling(sp<SignalerI> a_spSignaler,
						sp<Layout> a_spPollLayout);
		void	poll(void);

	private:
		Thread*				m_pChunkReceiverThread;
		ChunkReceiverTask	m_chunkReceiverTask;
		bool				m_operating;
		Poison				m_poison;
		bool				m_live;
		Mutex				m_liveMutex;
		sp<SignalerI>		m_spSignaler;
		Record				m_poll;

};

} /* namespace */

#endif /* __network_ChunkReciever_h__ */

